using System;

class PerformanceDemo
{
	static void Main(string[] args)
	{
		DateTime startTime = DateTime.Now;
		Console.WriteLine("Ineffective calculation started...");
		for (int i=0; i<5000; i++)
		{
			int[] buffer = new int[65536];
			for (int j=0; j<buffer.Length; j++) 
			{
				buffer[j] = j;
			}
		}
		TimeSpan duration = DateTime.Now - startTime;
		Console.WriteLine("Ineffective calculation finished.");
		Console.WriteLine("Ineffective calculation took {0} sec.",
			duration.TotalSeconds);

		startTime = DateTime.Now;
		Console.WriteLine("\nEffective calculation started...");
		int[] buffer2 = new int[65536];
		for (int i=0; i<5000; i++)
		{
			for (int j=0; j<buffer2.Length; j++) 
			{
				buffer2[j] = j;
			}
		}
		duration = DateTime.Now - startTime;
		Console.WriteLine("Effective calculation finished.");
		Console.WriteLine("Effective calculation took {0} sec.",
			duration.TotalSeconds);
	}
}
