using System;
using System.Collections;

class Resource
{
	internal Resource()
	{
		Console.WriteLine("Created resource.");
	}

	~Resource()
	{
		Console.WriteLine("Destroyed resource.");
	}
}

class ResourcePool
{
	private Stack mFreeStack = new Stack();

	public Resource GetInstance()
	{
		if (mFreeStack.Count != 0) 
		{
			// Return a resource from the pool
			Resource reusedResource =
				(Resource) mFreeStack.Pop();
			return reusedResource;
		} 
		else
		{
			// The pool is empty. Return new resource
			Resource newResource = new Resource();
			return newResource;
		}
	}

	public void FreeInstance(Resource aInstance)
	{
		mFreeStack.Push(aInstance);
	}
}

class ResourcePoolingDemo
{
	static void Main(string[] args)
	{
		ResourcePool pool = new ResourcePool();
		Resource r1 = pool.GetInstance();
		Resource r2 = pool.GetInstance();
		pool.FreeInstance(r2);
		Resource r3 = pool.GetInstance();
		// Actually r3 is the reused resource r2
	}
}
